"""
    independent_set_subspace([T, ]graph)

Create a subspace from given graph's maximal independent set.
"""
function independent_set_subspace(::Type{T}, graph::SimpleGraph) where T
    if isempty(edges(graph))
        @warn "graph has empty edges, creating a subspace contains the entire fullspace, consider using a full space register."
    end

    cg = complement(graph)
    mis = maximal_cliques(cg)
    n = nv(graph)
    return create_subspace_from_mis(T, n, mis)
end

function independent_set_subspace(graph::SimpleGraph)
    n = nv(graph)
    @assert n <= 128 "number of vertices in a graph is too large! $(n) > 128"
    independent_set_subspace(n > 64 ? Int128 : Int64, graph)
end

"""
    create_subspace_from_mis(T, n::Int, mis::AbstractVector)

Create `Subspace` from given list of maximal cliques/maximal independent set.

# Arguments

- `n`: number of vertices of the graph.
- `mis`: the list of maximal independent set.
"""
function create_subspace_from_mis(::Type{T}, n::Int, mis::AbstractVector) where T
    iterators = ThreadsX.map(mis) do each
        fixed_points = setdiff(1:n, each)
        locs = sort!(fixed_points)
        # copied from bsubspace to use runtime length
        masks, shift_len = group_shift(T, locs)
        len = one(T) << (n - length(locs))
        a = BitSubspace(n, len, length(masks), masks, shift_len)
        b = BitSubspace(n, len, length(masks), masks, shift_len)
        return BitSubspace(n, len, length(masks), masks, shift_len)
    end

    # NOTE: ThreadsX doesn't support auto init when using union as op
    # need the following PR merged
    # https://github.com/JuliaFolds/InitialValues.jl/pull/60
    subspace_v = ThreadsX.reduce(union, iterators; init = OnInit(Vector{T}))
    return Subspace(n, subspace_v)
end

"""
    blockade_subspace(atoms[, radius=1.0])

Create a blockade approximation subspace from given atom positions and radius.
"""
function blockade_subspace(atoms::AbstractVector, radius::AbstractFloat = 1.0)
    return independent_set_subspace(unit_disk_graph(atoms, radius))
end

# copied from BQCESubroutine
# should be removed after we release this package
# mainly because we want to use dynamic sized IterControl here

@inline lmove(b::Integer, mask::Integer, k::Int) = (b & ~mask) << k + (b & mask)

"""
    bmask(::Type{T}) where T <: Integer -> zero(T)
    bmask([T::Type], positions::Int...) -> T
    bmask([T::Type], range::UnitRange{Int}) -> T
Return an integer mask of type `T` where `1` is the position masked according to
`positions` or `range`. Directly use `T` will return an empty mask `0`.
"""
function bmask end

bmask(args...) = bmask(Int, args...)
bmask(::Type{T}) where {T<:Integer} = zero(T)
bmask(::Type{T}, positions::Int...) where {T<:Integer} = bmask(T, positions)

function bmask(::Type{T}, itr) where {T<:Integer}
    isempty(itr) && return 0
    ret = zero(T)
    for b in itr
        ret += one(T) << (b - 1)
    end
    return ret
end

@inline function bmask(::Type{T}, range::UnitRange{Int})::T where {T<:Integer}
    return ((one(T) << (range.stop - range.start + 1)) - one(T)) << (range.start - 1)
end

"""
    anyone(index::Integer, mask::Integer) -> Bool

Return `true` if any masked position of index is 1.

# Example
`true` if any masked positions is 1.
```jldoctest
julia> anyone(0b1011, 0b1001)
true
julia> anyone(0b1011, 0b1100)
true
julia> anyone(0b1011, 0b0100)
false
```
"""
anyone(index::T, mask::T) where {T<:Integer} = (index & mask) != zero(T)

"""
    ismatch(index::Integer, mask::Integer, target::Integer) -> Bool

Return `true` if bits at positions masked by `mask` equal to `1` are equal to `target`.

## Example

```julia
julia> n = 0b11001; mask = 0b10100; target = 0b10000;

julia> ismatch(n, mask, target)
true
```
"""
ismatch(index::T, mask::T, target::T) where {T<:Integer} = (index & mask) == target

@inline function _group_shift(masks::Vector{T}, shift_len::Vector{Int}, k::Int, k_prv::Int) where T<:Integer
    # if current position in the contiguous region
    # since these bits will be moved together with
    # the first one, we don't need to generate a
    # new mask
    if k == k_prv + 1
        shift_len[end] += 1
    else
        # we generate a bit mask where the 1st to k-th bits are 1
        push!(masks, bmask(T, 0:k-1))
        push!(shift_len, 1)
    end
end

@inline function group_shift(::Type{T}, locations) where T<:Integer
    masks = T[]
    shift_len = Int[]
    k_prv = -1
    for k in locations
        _group_shift(masks, shift_len, k, k_prv)
        k_prv = k
    end
    return masks, shift_len
end

struct BitSubspace{L}
    n::Int # number of bits in fullspace
    sz_subspace::L # size of the subspace
    n_shifts::Int # number of shifts
    masks::Vector{L} # shift masks
    shift_len::Vector{Int} # length of each shift
end

function Base.getindex(s::BitSubspace{T}, i::Integer) where T
    index = T(i - 1)
    @inbounds for k in 1:s.n_shifts
        index = lmove(index, s.masks[k], s.shift_len[k])
    end
    return index
end

Base.firstindex(s::BitSubspace) = 1
Base.lastindex(s::BitSubspace) = s.sz_subspace
Base.length(s::BitSubspace) = s.sz_subspace
Base.eltype(::BitSubspace{L}) where L = L

function Base.iterate(s::BitSubspace{T}, st::T = one(T)) where T
    st <= length(s) || return
    return s[st], st + one(T)
end

function Base.show(io::IO, ::MIME"text/plain", s::BitSubspace)
    indent = get(io, :indent, 0)
    println(io, " "^indent, s.sz_subspace, "-element BitSubspace:")
    if s.sz_subspace < 5
        for k in 1:s.sz_subspace
            print(io, " "^(indent + 1), string(s[k]; base = 2, pad = s.n))
            if k != s.sz_subspace
                println(io)
            end
        end
    else # never print more than 4 elements
        println(io, " "^(indent + 1), string(s[1]; base = 2, pad = s.n))
        println(io, " "^(indent + 1), string(s[2]; base = 2, pad = s.n))
        println(io, " "^(indent + 1), "⋮")
        println(io, " "^(indent + 1), string(s[end-1]; base = 2, pad = s.n))
        print(io, " "^(indent + 1), string(s[end]; base = 2, pad = s.n))
    end
end

module BloqadeMIS

using YaoAPI
using Graphs
using BloqadeExpr
using ThreadsX
using Random
using BitBasis
using Transducers
using Statistics
using EliminateGraphs
using YaoArrayRegister
using YaoSubspaceArrayReg

export rydberg_density_sum,
    gibbs_loss,
    is_independent_set,
    independent_set,
    independent_set_subspace,
    independent_set_probabilities,
    config_probability,
    to_independent_set,
    to_independent_set!,
    unit_disk_graph,
    mis_postprocessing,
    bitarray,
    count_vertices,
    blockade_subspace,
    SubspaceMap

include("loss.jl")
include("unit_disk_graph.jl")
include("bsubspace.jl")
include("subspace.jl")

end

using Test
using BloqadeMIS
using LinearAlgebra
using Random
using BitBasis
using YaoSubspaceArrayReg
using Graphs
using BloqadeMIS: add_vertices!, add_random_vertices
using FromFile
using BloqadeLattices
using Statistics

Random.seed!(1234)

@from "utils.jl" import test_subspace, test_graph

@testset "loss functions" begin
    constraint_r = zero_state(test_subspace)
    fullspace_r = zero_state(5)

    for loss_fn in [rydberg_density_sum, x -> gibbs_loss(x, 0.3)]
        @test loss_fn(constraint_r) == 0.0
        @test loss_fn(fullspace_r) == 0.0
        @test loss_fn(measure(fullspace_r; nshots = 10)) == 0.0
        @test loss_fn(measure(constraint_r; nshots = 10)) == 0.0
    end
end

# generate random atom positions
atoms = [(0.0, 1.0), (1.0, 0.0), (2.0, 0.0), (1.0, 1.0), (1.0, 2.0), (2.0, 2.0)]
graph = unit_disk_graph(atoms, 1.5)
config = [1, 1, 1, 0, 1, 1]

@test BloqadeMIS.num_mis_violation(config, graph, 1) == 2
@test BloqadeMIS.num_mis_violation(config, graph, 2) == 2
@test BloqadeMIS.num_mis_violation(config, graph, 3) == 1
@test BloqadeMIS.num_mis_violation(config, graph, 4) == 0
@test BloqadeMIS.num_mis_violation(config, graph, 5) == 2
@test BloqadeMIS.num_mis_violation(config, graph, 6) == 1

@test !is_independent_set(config, graph)
to_independent_set!(config, graph)
@test is_independent_set(config, graph)

@testset "mis probabilities" begin
    raw_state = normalize!(rand(ComplexF64, length(test_subspace)))
    r = SubspaceArrayReg(raw_state, test_subspace)
    @test sum(independent_set_probabilities(r, graph)) ≈ 1
    @test sum(independent_set_probabilities(mis_postprocessing(graph), r, graph)) ≈ 1

    @test independent_set_probabilities(r, graph)[1] ≈ config_probability(r, graph, BitArray([0, 0, 0, 0, 0, 0]))
    @test independent_set_probabilities(r, graph)[end] ≈ config_probability(r, graph, BitArray([1, 0, 1, 0, 0, 1]))
end

@testset "mis_postprocessing" begin
    config = [0, 0, 0, 0, 0]
    @test add_vertices!(config, test_graph, 1:5) == [1, 0, 1, 0, 1]
    @test add_random_vertices(config, test_graph) == [1, 0, 1, 0, 1]
    @test count_vertices(mis_postprocessing(0, test_graph)) > 0
end

@testset "SubspaceMap" begin
    atoms = generate_sites(SquareLattice(), 4, 4) |> random_dropout(0.2)
    graph = unit_disk_graph(atoms, 1.5)
    space = independent_set_subspace(graph)
    reg = rand_state(space)
    Random.seed!(1234)
    l1 = rydberg_density_sum(mis_postprocessing(graph), reg)
    Random.seed!(1234)
    l2 = rydberg_density_sum(SubspaceMap(mis_postprocessing(graph), space), reg)
    @test l1 ≈ l2
end


@testset "indepent set subspace with no edges" begin
    no_edges_warning = "graph has empty edges, creating a subspace contains the entire fullspace, consider using a full space register."
    no_edges_graph = Graph(5)

    @test_logs (:warn, no_edges_warning) independent_set_subspace(no_edges_graph)

    atoms = generate_sites(RectangularLattice(1.0), 3, 3; scale = 4.5)
    @test_logs (:warn, no_edges_warning) blockade_subspace(atoms)
end

@testset "exact/sample based loss function" begin
    r = rand_state(5)
    samples = measure(r; nshots = 10000)
    expected_sampling = samples .|> count_vertices |> mean
    # 2. exact
    expected_exact = r |> rydberg_density_sum
    @test isapprox(expected_exact, expected_sampling; rtol = 1e-1)

    ####### gibbs
    Random.seed!(5)
    # 1. sampling
    expected_sampling = r |> measure(nshots = 10000) |> gibbs_loss(0.5)
    # 2. exact
    expected_exact = r |> gibbs_loss(0.5)
    @test isapprox(expected_exact, expected_sampling; rtol = 1e-1)
end

@testset "128 bit" begin
    s = independent_set_subspace(Int128, Graphs.complete_graph(66))
    @test length(s) == 67
    @test s.subspace_v == Int128[one(Int128)<<(i-1) for i=0:66]
end

using Test
using Random
using BloqadeMIS
using BloqadeExpr
using BloqadeLattices
using Graphs

@testset "unit_disk" begin
    g = SimpleGraph(4)
    positions = [0 0 0.3 0.4; 0 0.6 0 0.6]
    atms = matrix_to_positions(positions)
    g2 = unit_disk_graph(atms)
    @test ne(g2) == 6

    radius = 0.5
    for edge in [(1, 3), (2, 4)]
        add_edge!(g, edge)
    end

    h = unit_disk_graph(atms, radius)
    @test g == h

    radius = sqrt(0.3^2 + 0.6^2) + 0.01
    g2 = complete_graph(4)
    rem_edge!(g2, 1, 4)

    h2 = unit_disk_graph(atms, radius)
    @test g2 == h2
end

using Test
using BloqadeMIS

if "docstring" in ARGS
    # include("docstrings.jl")
    exit()
end

@testset "unit_disk_graph" begin
    include("unit_disk_graph.jl")
end

@testset "utils" begin
    include("utils.jl")
end

@testset "loss" begin
    include("loss.jl")
end

"""
    count_vertices(config::Integer)

counter the number of vertices in a spin configuration.
"""
count_vertices(config::Integer) = count_ones(config)
count_vertices(config::AbstractVector) = count(isone, config)

"""
    rydberg_density_sum([f], reg_or_samples)

Sum of rydberg density.

# Arguments

- `f`: optional, postprocessing callback function `f(config) -> config`.
    The input `config` is an integer of type `Int`, the output
    `config` can be a type supports [`count_vertices`](@ref)
    e.g, an `AbstractVector` or an `Integer`.
- `reg_or_samples` can be a register (`Yao.ArrayReg` or [`SubspaceArrayReg`](@ref))
    or a list of measurement result (config) in `AbstractVector`.

# Example

To implement the postprocessing protocal in MIS experiment:

1. calculating `rydberg_density_sum` by first reducing the configuration
to independent set using [`to_independent_set`](@ref)
2. randomly adding vertices then pick the largest [`count_vertices`](@ref)
using [`add_random_vertices`](@ref).

```julia
rydberg_density_sum(r) do config
    config = to_independent_set(config, graph)
    add_random_vertices(config, graph, 10)
    return config
end
```

Or one can also just add vertice by atom order

```julia
rydberg_density_sum(r) do config
    config = to_independent_set(config, graph)
    add_vertices!(config, graph)
    return config
end
```
"""
function rydberg_density_sum end

rydberg_density_sum(x) = rydberg_density_sum(identity, x)

struct SubspaceMap
    d::Dict{Int,Int}
end

function SubspaceMap(f, subspace::Subspace)
    key = Vector{Int}(undef, length(subspace))
    val = Vector{Int}(undef, length(subspace))
    origin = vec(subspace)
    @inbounds Threads.@threads for idx in 1:length(origin)
        cfg = origin[idx]
        key[idx] = cfg
        val[idx] = to_int64(f(cfg))
    end
    return SubspaceMap(Dict{Int,Int}(zip(key, val)))
end

Base.length(map::SubspaceMap) = length(map.d)
Base.getindex(map::SubspaceMap, cfg::Int) = map.d[cfg]
(map::SubspaceMap)(cfg::Int) = map[cfg]

function to_int64(b::BitVector) # workaround type piracy
    length(b) <= 64 || throw(ArgumentError("length is larger than 64"))
    # NOTE: since we only use this to calculate number of ones
    # thus we don't need to check top bit
    return reinterpret(Int, b.chunks[1])
end

struct ConfigAmplitude{Reg<:YaoAPI.AbstractRegister}
    reg::Reg
    range::UnitRange{Int}
end

ConfigAmplitude(reg::YaoAPI.AbstractRegister{2}) = ConfigAmplitude(reg, 1:size(reg.state, 1))

Base.eltype(it::ConfigAmplitude) = Tuple{Int,datatype(it.reg)}
Base.length(it::ConfigAmplitude) = length(it.range)

function Transducers.halve(it::ConfigAmplitude)
    left, right = Transducers.halve(it.range)
    return ConfigAmplitude(it.reg, left), ConfigAmplitude(it.reg, right)
end

function Base.iterate(it::ConfigAmplitude{<:SubspaceArrayReg}, idx::Int = first(it.range))
    idx > last(it.range) && return
    cfg = it.reg.subspace.subspace_v[idx]
    @inbounds amp = it.reg.state[idx]
    return (cfg, amp), idx + 1
end

function Base.iterate(it::ConfigAmplitude{<:ArrayReg}, idx::Int = first(it.range))
    idx > last(it.range) && return
    return (idx - 1, it.reg.state[idx]), idx + 1
end

function rydberg_density_sum(f, reg::YaoAPI.AbstractRegister)
    return sum(ConfigAmplitude(reg)) do (c, amp)
        nvertices = count_vertices(f(c))
        return abs2(amp) * nvertices
    end
end

function rydberg_density_sum(f, samples::AbstractVector)
    return mean(count_vertices ∘ f, samples)
end

"""
    gibbs_loss([f], reg_or_samples, α::Real)

The Gibbs loss for maximum independent set defined as

```math
L = -1/α \\log(\\langle ψ|\\exp(α \\sum(n))|ψ\\rangle),
```

where `n` is the vertex set size.

# Arguments

- `f`: optional, postprocessing callback function `f(config) -> config`.
    The input `config` is an integer of type `Int`, the output
    `config` can be a type supports [`count_vertices`](@ref)
    e.g, an `AbstractVector` or an `Integer`.
- `reg_or_samples` can be a register (`Yao.ArrayReg` or [`SubspaceArrayReg`](@ref))
    or a list of measurement result (config) in `AbstractVector`.
- `α::Real`: the parameter of Gibbs loss.
"""
gibbs_loss(reg_or_samples, α::Real) = gibbs_loss(identity, reg_or_samples, α)

function gibbs_loss(f, reg::YaoAPI.AbstractRegister, α::Real)
    expected = ThreadsX.sum(ConfigAmplitude(reg)) do (config, amp)
        return abs2(amp) * exp(α * count_vertices(f(config)))
    end
    return -log(expected) / α
end

function logsumexp(x::AbstractArray)
    xmax = maximum(x)
    return log(sum(exp.(x .- xmax))) + xmax
end

function gibbs_loss(f, samples::AbstractVector, α::Real)
    expect = ThreadsX.map(x -> α * count_vertices(f(x)), samples)
    return -(logsumexp(expect) - log(length(samples))) / α
end

function gibbs_loss(f, samples::AbstractMatrix, α::Real)
    return -(logsumexp(α .* sum(samples, dims = (2,))) - log(size(samples, 1))) / α
end

gibbs_loss(α::Real) = reg -> gibbs_loss(reg, α)

"""
    is_independent_set(config, graph::AbstractGraph)

Return `true` if `config` is an independent set of graph.
`config` can be a `BitStr`, a vector, or any iterable.
"""
function is_independent_set(config, graph::AbstractGraph)
    for i in 1:nv(graph)
        for j in i+1:nv(graph)
            config[i] == 1 && config[j] == 1 && has_edge(graph, i, j) && return false
        end
    end
    return true
end

"""
    to_independent_set!(config::AbstractVector, graph::AbstractGraph)

Eliminate vertices in `config` so that remaining vertices do not have connected edges.
This algorithm is a naive vertex elimination that does not nesesarily give the maximum possible vertex set.

```@example
# run the following code in Atom/VSCode
atoms = [(0.0, 1.0), (1.0, 0.), (2.0, 0.0), (1.0, 1.0), (1.0, 2.0), (2.0, 2.0)]
graph = unit_disk_graph(atoms, 1.5)

config = [1, 1, 1, 0, 1, 1]
viz_config(atoms, graph, config)

to_independent_set!(config, graph)
viz_config(atoms, graph, config)
```
"""
function to_independent_set!(config::AbstractVector, graph::AbstractGraph)
    N = length(config)
    n = typemax(Int)
    while true
        n, loc = findmax(map(i -> num_mis_violation(config, graph, i), 1:N))
        if n == 0
            break
        else
            config[loc] = 0
        end
    end
    return config
end

"""
    to_independent_set(config::Integer, graph::AbstractGraph)

Eliminate vertices in `config` so that remaining vertices do not have connected edges
without changing the original config, see also [`to_independent_set!`](@ref).
"""
function to_independent_set(config::Integer, graph::AbstractGraph)
    return to_independent_set!(bitarray(config, nv(graph)), graph)
end

function to_independent_set(config::AbstractVector{<:Integer}, graph::AbstractGraph)
    return to_independent_set!(copy(config), graph)
end

"""
    num_mis_violation(config, graph::AbstractGraph, i::Int)

Calculate the number of MIS violations for `i`-th vertex in `graph`
and configuration `config`. The `config` should be a subtype of
`AbstractVector`.
"""
Base.@propagate_inbounds function num_mis_violation(config, graph::AbstractGraph, i::Int)
    ci = config[i]
    ci == 1 || return 0

    return count(1:length(config)) do j
        return config[j] == 1 && has_edge(graph, i, j)
    end
end

"""
    exact_solve_mis(g::AbstractGraph)

Return the exact MIS size of a graph `g`.
"""
exact_solve_mis(g::AbstractGraph) = mis2(EliminateGraph(adjacency_matrix(g)))

"""
    add_random_vertices([rng=GLOBAL_RNG], config::AbstractVector, graph::AbstractGraph, ntrials::Int = 10)

Add vertices randomly to given configuration for `ntrials` times and
pick the one that has largest [`count_vertices`](@ref).

# Arguments

- `rng`: optional, Random Number Generator.
- `config`: configuration to tweak.
- `graph`: problem graph.
- `ntrials`: number of trials to use, default is `10`.
"""
function add_random_vertices(config::AbstractVector, graph::AbstractGraph, ntrials::Int = 10)
    return add_random_vertices(Random.GLOBAL_RNG, config, graph, ntrials)
end

function add_random_vertices(rng::AbstractRNG, config::AbstractVector, graph::AbstractGraph, ntrials::Int = 10)
    perm = collect(1:nv(graph))
    nvertices = count_vertices(config)
    origin = config
    maximum_config = copy(origin)
    config_candidate = copy(origin)

    for _ in 1:ntrials
        randperm!(rng, perm)
        copyto!(config_candidate, origin)
        add_vertices!(config_candidate, graph, perm)
        nvertices_candidate = count_vertices(config_candidate)
        if nvertices_candidate > nvertices
            copyto!(maximum_config, config_candidate)
            nvertices = nvertices_candidate
        end
    end
    return maximum_config
end

add_vertices(config::AbstractVector, graph::AbstractGraph, perm = eachindex(config)) =
    add_vertices!(copy(config), graph, perm)

function add_vertices!(config::AbstractVector, graph::AbstractGraph, perm = eachindex(config))
    for (k, c) in zip(perm, config)
        if iszero(c)
            config[k] = 1
            if is_independent_set(config, graph)
                continue
            else
                config[k] = 0
            end
        end
    end
    return config
end

"""
    independent_set_probabilities([f], reg::YaoAPI.AbstractRegister, graph_or_mis)

Calculate the probabilities of independent sets with given postprocessing function
`f(config) -> config`. The default postprocessing function `f` will only reduce all
configurations to independent set.

# Arguments

- `f`: optional, postprocessing function, default is [`to_independent_set`](@ref).
- `reg`: required, the register object.
- `graph_or_mis`: a problem graph or the MIS size of the problem
    graph (can be calculated via [`exact_solve_mis`](@ref)).
"""
function independent_set_probabilities end

function independent_set_probabilities(reg::YaoAPI.AbstractRegister, graph::AbstractGraph)
    independent_set_probabilities(reg, graph) do config
        return to_independent_set(config, graph)
    end
end

function independent_set_probabilities(f, reg::YaoAPI.AbstractRegister, graph::AbstractGraph)
    return independent_set_probabilities(f, reg, exact_solve_mis(graph))
end

function independent_set_probabilities(f, reg::YaoAPI.AbstractRegister, mis::Int)
    v2amp = ThreadsX.map(ConfigAmplitude(reg)) do (c, amp)
        return count_vertices(f(c)), amp
    end

    return ThreadsX.map(0:mis) do k
        ThreadsX.sum(v2amp) do (nvertices, amp)
            return sum_amp(nvertices == k, amp)
        end
    end
end

function config_probability end

function config_probability(reg::YaoAPI.AbstractRegister, graph::AbstractGraph, independent_set_config)
    config_probability(reg, graph, independent_set_config) do config
        return to_independent_set(config, graph)
    end
end

function config_probability(f, reg::YaoAPI.AbstractRegister, graph::AbstractGraph, independent_set_config)
    mis_postprocessed = to_independent_set!(independent_set_config, graph)
    v2amp = ThreadsX.map(ConfigAmplitude(reg)) do (c, amp)
        return f(c), amp
    end
    return ThreadsX.sum(v2amp) do (b, amp)
        return sum_amp(b == mis_postprocessed, amp)
    end
end

function sum_amp(condition, amp)
    if condition
        return abs2(amp)
    else
        return zero(real(typeof(amp)))
    end
end

"""
    mis_postprocessing(config, graph::AbstractGraph; ntrials::Int=10)

The postprocessing protocal used in Harvard experiment for finding MISs: [arxiv:2202.09372](https://arxiv.org/abs/2202.09372),
which includes a combination of [`to_independent_set`](@ref) and [`add_random_vertices`](@ref).

# Arguments

- `config`: configuration to postprocess.
- `graph`: the problem graph.

# Keyword Arguments

- `ntrials`: number of trials to use.
"""
function mis_postprocessing(config, graph::AbstractGraph; ntrials::Int = 10)
    config = to_independent_set(config, graph)
    config = add_random_vertices(config, graph, ntrials)
    return config
end

"""
    mis_postprocessing(graph::AbstractGraph; ntrials::Int = 10)

Curried version of [`mis_postprocessing`](@ref).

# Example

to calculate `rydberg_density_sum` loss with postprocessing used in
Harvard experiment: [arxiv:2202.09372](https://arxiv.org/abs/2202.09372).

```julia
rydberg_density_sum(mis_postprocessing(graph), reg)
```
"""
function mis_postprocessing(graph::AbstractGraph; ntrials::Int = 10)
    return function postprocessing(config)
        return mis_postprocessing(config, graph; ntrials)
    end
end

"""
    unit_disk_graph(atoms::AbstractVector, radius=1)

Create a unit disk graph from atom positions `atoms`. It returns a `Graphs.SimpleGraph` instance.
* `atoms` is vector of atoms positions.
* `radius` is the unit in the unit disk graph definition.
"""
function unit_disk_graph(atoms::AbstractVector, radius = 1)
    n_atoms = length(atoms)
    g = SimpleGraph(n_atoms)

    for k in 1:n_atoms
        indices = findall(atoms) do x
            return BloqadeExpr.distance(atoms[k], x) <= radius
        end

        for p in indices
            if k != p
                add_edge!(g, k, p)
            end
        end
    end

    return g
end
